using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Xml;
using System.IO;
using System.Xml.Schema;

namespace Ecpts.Tools.XmlValidator
{

	/// <summary>
	/// The main and only form in the mini-app.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label instructionsLabel;
		private System.Windows.Forms.Button importButton;
		private System.Windows.Forms.TextBox inputXmlTextBox;
		private System.Windows.Forms.Label xmlToValidateLabel;
		private System.Windows.Forms.OpenFileDialog importOpenFileDialog;
		private System.Windows.Forms.Button selectSchemaButton;
		private System.Windows.Forms.TextBox xmlSchemaFileTextBox;
		private System.Windows.Forms.OpenFileDialog schemaOpenFileDialog;
		private System.Windows.Forms.Label resultLabel;
		private System.Windows.Forms.TextBox resultTextBox;
		private System.Windows.Forms.Button resetFormButton;
		private System.Windows.Forms.Button validateButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.instructionsLabel = new System.Windows.Forms.Label();
			this.importButton = new System.Windows.Forms.Button();
			this.inputXmlTextBox = new System.Windows.Forms.TextBox();
			this.xmlToValidateLabel = new System.Windows.Forms.Label();
			this.importOpenFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.selectSchemaButton = new System.Windows.Forms.Button();
			this.xmlSchemaFileTextBox = new System.Windows.Forms.TextBox();
			this.schemaOpenFileDialog = new System.Windows.Forms.OpenFileDialog();
			this.resultLabel = new System.Windows.Forms.Label();
			this.resultTextBox = new System.Windows.Forms.TextBox();
			this.resetFormButton = new System.Windows.Forms.Button();
			this.validateButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// instructionsLabel
			// 
			this.instructionsLabel.Location = new System.Drawing.Point(8, 8);
			this.instructionsLabel.Name = "instructionsLabel";
			this.instructionsLabel.Size = new System.Drawing.Size(344, 16);
			this.instructionsLabel.TabIndex = 0;
			this.instructionsLabel.Text = "Copy-Paste the XML to validate or click Import XML to read a file: ";
			// 
			// importButton
			// 
			this.importButton.Location = new System.Drawing.Point(352, 8);
			this.importButton.Name = "importButton";
			this.importButton.Size = new System.Drawing.Size(120, 23);
			this.importButton.TabIndex = 1;
			this.importButton.Text = "Import XML...";
			this.importButton.Click += new System.EventHandler(this.importButton_Click);
			// 
			// inputXmlTextBox
			// 
			this.inputXmlTextBox.AcceptsReturn = true;
			this.inputXmlTextBox.AcceptsTab = true;
			this.inputXmlTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.inputXmlTextBox.Location = new System.Drawing.Point(8, 64);
			this.inputXmlTextBox.Multiline = true;
			this.inputXmlTextBox.Name = "inputXmlTextBox";
			this.inputXmlTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.inputXmlTextBox.Size = new System.Drawing.Size(640, 224);
			this.inputXmlTextBox.TabIndex = 2;
			this.inputXmlTextBox.Text = "";
			// 
			// xmlToValidateLabel
			// 
			this.xmlToValidateLabel.Location = new System.Drawing.Point(8, 32);
			this.xmlToValidateLabel.Name = "xmlToValidateLabel";
			this.xmlToValidateLabel.TabIndex = 3;
			this.xmlToValidateLabel.Text = "XML to validate:";
			// 
			// importOpenFileDialog
			// 
			this.importOpenFileDialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
			// 
			// selectSchemaButton
			// 
			this.selectSchemaButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.selectSchemaButton.Location = new System.Drawing.Point(8, 296);
			this.selectSchemaButton.Name = "selectSchemaButton";
			this.selectSchemaButton.Size = new System.Drawing.Size(208, 23);
			this.selectSchemaButton.TabIndex = 4;
			this.selectSchemaButton.Text = "Select an XML Schema file:";
			this.selectSchemaButton.Click += new System.EventHandler(this.selectSchemaButton_Click);
			// 
			// xmlSchemaFileTextBox
			// 
			this.xmlSchemaFileTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.xmlSchemaFileTextBox.Enabled = false;
			this.xmlSchemaFileTextBox.ForeColor = System.Drawing.SystemColors.InfoText;
			this.xmlSchemaFileTextBox.Location = new System.Drawing.Point(8, 328);
			this.xmlSchemaFileTextBox.Name = "xmlSchemaFileTextBox";
			this.xmlSchemaFileTextBox.Size = new System.Drawing.Size(640, 20);
			this.xmlSchemaFileTextBox.TabIndex = 5;
			this.xmlSchemaFileTextBox.Text = "";
			// 
			// schemaOpenFileDialog
			// 
			this.schemaOpenFileDialog.Filter = "XML Schema Definition (*.xsd)|*.xsd|All files (*.*)|*.*";
			// 
			// resultLabel
			// 
			this.resultLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.resultLabel.Location = new System.Drawing.Point(104, 360);
			this.resultLabel.Name = "resultLabel";
			this.resultLabel.Size = new System.Drawing.Size(100, 24);
			this.resultLabel.TabIndex = 6;
			this.resultLabel.Text = "Result:";
			// 
			// resultTextBox
			// 
			this.resultTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.resultTextBox.ForeColor = System.Drawing.SystemColors.WindowText;
			this.resultTextBox.Location = new System.Drawing.Point(8, 392);
			this.resultTextBox.Multiline = true;
			this.resultTextBox.Name = "resultTextBox";
			this.resultTextBox.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.resultTextBox.Size = new System.Drawing.Size(640, 128);
			this.resultTextBox.TabIndex = 7;
			this.resultTextBox.Text = "";
			// 
			// resetFormButton
			// 
			this.resetFormButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.resetFormButton.Location = new System.Drawing.Point(472, 360);
			this.resetFormButton.Name = "resetFormButton";
			this.resetFormButton.Size = new System.Drawing.Size(176, 24);
			this.resetFormButton.TabIndex = 8;
			this.resetFormButton.Text = "Reset for new validation";
			this.resetFormButton.Click += new System.EventHandler(this.resetFormButton_Click);
			// 
			// validateButton
			// 
			this.validateButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.validateButton.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.validateButton.Location = new System.Drawing.Point(16, 360);
			this.validateButton.Name = "validateButton";
			this.validateButton.TabIndex = 9;
			this.validateButton.Text = "Validate!";
			this.validateButton.Click += new System.EventHandler(this.validateButton_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(664, 534);
			this.Controls.Add(this.validateButton);
			this.Controls.Add(this.resetFormButton);
			this.Controls.Add(this.resultTextBox);
			this.Controls.Add(this.resultLabel);
			this.Controls.Add(this.xmlSchemaFileTextBox);
			this.Controls.Add(this.selectSchemaButton);
			this.Controls.Add(this.xmlToValidateLabel);
			this.Controls.Add(this.inputXmlTextBox);
			this.Controls.Add(this.importButton);
			this.Controls.Add(this.instructionsLabel);
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "XML Validator";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Constructor for the MainForm
		/// </summary>
		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Reset the form controls to do a new xml validation
		/// </summary>
		private void ResetForm()
		{
			inputXmlTextBox.Text = String.Empty;
			xmlSchemaFileTextBox.Text = String.Empty;
			resultTextBox.Text = String.Empty;
		}

		/// <summary>
		/// Checks whether the user input is valid befor processing the
		/// XML Validation
		/// </summary>
		/// <returns>whether the form values are valid</returns>
		private bool ValidateForm()
		{
			bool isValid = false;
			if ( (inputXmlTextBox.Text.Trim() != String.Empty) && (xmlSchemaFileTextBox.Text.Trim() != String.Empty)) 
			{
				isValid = true;
			}
			return isValid;
		}

		private void importButton_Click(object sender, System.EventArgs e)
		{
			// read the selected file into the textbox
			if (importOpenFileDialog.ShowDialog() == DialogResult.OK) 
			{
				try {
					inputXmlTextBox.Text = String.Empty;
					inputXmlTextBox.Text = File.OpenText(importOpenFileDialog.FileName).ReadToEnd();
				} catch (Exception ex) {
					MessageBox.Show(null, ex.ToString(), "Error reading XML file", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}

		}

		private void resetFormButton_Click(object sender, System.EventArgs e)
		{
			ResetForm();
		}

		private void selectSchemaButton_Click(object sender, System.EventArgs e)
		{
			// read the selected file into the textbox
			if (schemaOpenFileDialog.ShowDialog() == DialogResult.OK) 
			{
				try 
				{
					xmlSchemaFileTextBox.Text = schemaOpenFileDialog.FileName;
				} 
				catch (Exception ex) 
				{
					MessageBox.Show(null, ex.ToString(), "Error reading XML Schema file", 
						MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}

		private void validateButton_Click(object sender, System.EventArgs e)
		{
			// do validation of the data on the form
			resultTextBox.Text = String.Empty;
			if (ValidateForm())
			{
				try 
				{
                    Cursor.Current = Cursors.WaitCursor;

                    XmlSchemaSet schemaSet = new XmlSchemaSet();
                    schemaSet.Add(String.Empty,
                        XmlReader.Create(new StreamReader(xmlSchemaFileTextBox.Text)));

                    XmlReaderSettings settings = new XmlReaderSettings();
                    settings.Schemas = schemaSet;
                    settings.ValidationType = ValidationType.Schema;
                   
                    XmlReader reader = XmlReader.Create(
                        new StringReader(inputXmlTextBox.Text), settings);

                    while (reader.Read()) { }

                    resultTextBox.Text = "Document is valid :o)" +
                    DateTime.Now.ToLongDateString();

				} 
				catch (XmlSchemaException schemaEx) 
				{
					resultTextBox.Text = "Document is NOT VALID:" + Environment.NewLine + schemaEx.Message;
				}
				catch (Exception ex) 
				{
					resultTextBox.Text = ex.ToString();
				}
				finally
				{
					Cursor.Current = Cursors.Default;
				}
			}
			else 
			{
				MessageBox.Show(null, 
					"You must provide, an XML document and a Schema to proceed with validation",
					"Error reading Validating XML file", 
					MessageBoxButtons.OK, MessageBoxIcon.Error);
			}


		}

	}
}
